//*****************************************************************
// 
//  JAVA Source for com.idautomation.maxicode; 2017
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.maxicode;

import javax.imageio.ImageIO;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
/** This is the MaxiCode servlet that creates a barcode from the MaxiCode class. */
    public class IDAutomationServlet  extends HttpServlet
    {
        /**
         * Handle the HTTP POST method by sending an e-mail
         *
         *
         */

	    public void init() throws ServletException  {

	    }

       // read paramters from request and create barcode
       public MaxiCode getBarcode (HttpServletRequest request) {

       	  MaxiCode cb=new MaxiCode();

          //cb.setMode(2);
          //cb.setZipCode("11111");
          //cb.setServiceClass("222");
          //cb.setCountry("333");
          //cb.setData("NO DATA ENTERED");

          if (request==null) {
             cb.setMode(4);
             cb.setData("NO DATA ENTERED");
	     return cb;
          }

          // READ DATA
          String dataStr=request.getParameter("DATA");
          if (dataStr!=null) cb.setData(dataStr);
          if(request.getParameter("D")!=null)
              cb.setData(request.getParameter("D"));



          String mode=request.getParameter("MODE");
          if(request.getParameter("M")!=null)
              mode=request.getParameter("M");
          if (mode!=null) {
             if (mode.compareTo("2")==0) cb.setMode(2);
             if (mode.compareTo("3")==0) cb.setMode(3);
             if (mode.compareTo("4")==0) cb.setMode(4);
             if (mode.compareTo("5")==0) cb.setMode(5);
             if (mode.compareTo("6")==0) cb.setMode(6);
          }
          
          if (request.getParameter("PT")!=null)
          {
              String PTParameter = request.getParameter("PT");
              if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                 PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                  cb.setProcessTilde(true);
              else
                  cb.setProcessTilde(false);
          }

          // ROTATION
          String rot=request.getParameter("ROTATION");
          if(request.getParameter("O")!=null)
              rot=request.getParameter("O");
          cb.setRotation(0);
          if (rot!=null) {
             if (rot.compareTo("90")==0) cb.setRotation(90);
             if (rot.compareTo("180")==0) cb.setRotation(180);
             if (rot.compareTo("270")==0) cb.setRotation(270);
          }

          // RESOLUTION
          String res=request.getParameter("RESOLUTION");
          if(request.getParameter("IR")!=null)
              res=request.getParameter("IR");
          if (res!=null) {
             int resInt=0;
             try {
               resInt=Integer.parseInt(res);
             } catch (Exception e) {};

             if ((resInt>=72) && (resInt<=600)) cb.setResolution(resInt);

          }

          if (request.getParameter("BC")!=null) cb.color=convertColor(request.getParameter("BC"));
          if (request.getParameter("BGC")!=null) cb.backColor=convertColor(request.getParameter("BGC"));
          // READ PRIMARY MESSAGE DATA
          String PC=request.getParameter("POSTALCODE");
          if (PC!=null) cb.setZipCode(PC);

          String Service=request.getParameter("SERVICE");
          if (Service!=null) cb.setServiceClass(Service);

          String country=request.getParameter("COUNTRY");
          if (country!=null) cb.setCountry(country);

          // STRUCTURED APPEND DATA
          String symbols=request.getParameter("NUMBER");
          if (symbols!=null) {
             if (symbols.compareTo("2")==0) cb.setNumberOfCodes(2);
             if (symbols.compareTo("3")==0) cb.setNumberOfCodes(3);
             if (symbols.compareTo("4")==0) cb.setNumberOfCodes(4);
             if (symbols.compareTo("5")==0) cb.setNumberOfCodes(5);
             if (symbols.compareTo("6")==0) cb.setNumberOfCodes(6);
             if (symbols.compareTo("7")==0) cb.setNumberOfCodes(7);
             if (symbols.compareTo("8")==0) cb.setNumberOfCodes(8);
          }

          String symbol=request.getParameter("POSITION");
          if (symbol!=null) {
             if (symbol.compareTo("2")==0) cb.setPositionOfCode(2);
             if (symbol.compareTo("3")==0) cb.setPositionOfCode(3);
             if (symbol.compareTo("4")==0) cb.setPositionOfCode(4);
             if (symbol.compareTo("5")==0) cb.setPositionOfCode(5);
             if (symbol.compareTo("6")==0) cb.setPositionOfCode(6);
             if (symbol.compareTo("7")==0) cb.setPositionOfCode(7);
             if (symbol.compareTo("8")==0) cb.setPositionOfCode(8);

          }

          return cb;


       }
       
    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }
       
       // Handle a request
       // 1. create barcode
       // 2. draw barcode in a Buffered Image
       // 3. encode image as GIF or JPEG and send it to the browser
        public void doGet (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException, IOException
        {
			PrintWriter		out;
			ServletOutputStream outb;

			//default encoding type
			String encode="jpeg";
			if (request!=null) 
			{
				if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();
                                if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
				if (encode.compareTo("gif")!=0) encode="jpeg";
			}
			response.setContentType("image/"+encode);
			outb=response.getOutputStream();

			// avoid caching in browser
			response.setHeader ("Pragma", "no-cache");
			response.setHeader ("Cache-Control", "no-cache");
			response.setDateHeader ("Expires",0);

			// get BarCode
			MaxiCode cb=getBarcode(request);

		try { // Create buffer

			java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(cb.getPreferredSize().width,cb.getPreferredSize().height,java.awt.image.BufferedImage.TYPE_INT_RGB);
			java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
			cb.setSize(cb.getPreferredSize());
			cb.paint(BarGraphics);

			if (encode.compareToIgnoreCase("gif")==0) 
			{
				// encode buffered image to a gif
				com.idautomation.maxicode.encoder.GifEncoder encoder = new com.idautomation.maxicode.encoder.GifEncoder(BarImage  ,outb);
				encoder.encode();
			}
			else
			{
				// open file
           // java.io.File f=new java.io.File(sFile);
            //f.delete();
           // java.io.FileOutputStream of=new java.io.FileOutputStream(f);

            // encode buffered image to a jpeg
            //com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(of ); BRJ 9/2016 Not compatible with Java 7
            //increase the JPEG quality to 100%
            //com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( image ); BRJ 9/2016 Not compatible with Java 7
			//param.setQuality(1.0F,true);
            //encoder.setJPEGEncodeParam(param); BRJ 9/2016 Not compatible with java 7. Java 7 now uses ImageIO.write
            // encoder.encode( image,param ); 
		    
			ImageIO.write(BarImage, "jpeg", outb);  //BRJ Replaces com.sun.image.codec for Java version 1.4 and up.  9/2016
           // of.close();	

			}


		} catch (Exception e) { e.printStackTrace();}

               //outb.close();

		}


        public void doPost (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException
        {
        try {
            doGet(request,response);
            } catch (Exception e) { e.printStackTrace();}
	}

    }


